/* AMX Mod X
*   IP functions
*
* (c) Copyright 2007 by VEN
*
* This file is provided as is (no warranties)
*/

#if defined _ip_included
	#endinput
#endif

#define _ip_included


// gets integer value of D sub-IP from given IP address; returns -1 on failure
stock get_dsubip_val(const ip[]) {
	static i
	for (i = strlen(ip) - 2; i != 4; --i) {
		if (ip[i] == '.')
			return str_to_num(ip[i + 1])
	}

	return -1
}

// gets min and max integer values of D sub-IP range from given IP construction; returns true on success and false on failure
stock bool:get_dsubip_range(const ip[], &min, &max, token = '-') {
	static i
	for (i = strlen(ip) - 2; i != 4; --i) {
		if (ip[i] == '.') {
			static szMin[4], szMax[sizeof szMin]
			strtok(ip[i + 1], szMin, sizeof szMin - 1, szMax, sizeof szMax - 1, token)
			min = str_to_num(szMin)
			max = str_to_num(szMax)
			return true
		}
	}

	return false
}

// returns true if given IPs/IP constructions belong to a net of D class, i.e. use the same D-subnet and false otherwise
stock bool:is_d_subnet(const ip1[], const ip2[]) {
	static i
	for (i = strlen(ip1) - 2; i != 4; --i) {
		if (ip1[i] == '.')
			return !!equal(ip1, ip2, i)
	}

	return false
}

/* Formats IP:Port or IP string
* Example: "80.137.49.5:1026" to " 80.137. 49.  5: 1026" */
stock format_ipp(ipp[22]) {
	new pos1 = strlen(ipp) - 1
	new port = (contain(ipp, ":") != -1)
	new a = 4 + port
	new b = 3 + 2 * port
	new temp[22]
	new pos2 = 14 + 6 * port
	for (new i = 0; i < a; ++i) {
		for (new j = 0; j < b; ++j) {
			if (pos1 >= 0 && isdigit(ipp[pos1])) {
				temp[pos2] = ipp[pos1]
				pos1--
			}
			else
				temp[pos2] = ' '
			pos2--
		}
		if (pos2 < 0)
			break
		if (b == 3)
			temp[pos2] = '.'
		else
			temp[pos2] = ':'
		pos1--
		pos2--
		b = 3
	}
	ipp = temp
}
